<?php

/**
 * @version   1.11 February 9, 2017
 * @author    RocketTheme, LLC http://www.rockettheme.com
 * @copyright Copyright (C) 2007 - 2017 RocketTheme, LLC
 * @license   http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
 */
/*
Plugin Name: RokIntroScroller
Plugin URI: http://www.rockettheme.com
Description: RokIntroScroller is a mootools based plugin that scrolls your posts in a horizontal manner. The plugin works by loading articles from designated category inside the styled, javascript effect.
Author: RocketTheme, LLC
Version: 1.11
Author URI: http://www.rockettheme.com
License: http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
*/

// Globals

global $rokintroscroller_plugin_path, $rokintroscroller_plugin_url, $platform;
if(!is_multisite()) {
	$rokintroscroller_plugin_path = dirname($plugin);
} else {
	if(!empty($network_plugin)) {
		$rokintroscroller_plugin_path = dirname($network_plugin);
	} else {
		$rokintroscroller_plugin_path = dirname($plugin);
	}
}
$rokintroscroller_plugin_url = WP_PLUGIN_URL . '/' . basename($rokintroscroller_plugin_path);

require(dirname(__FILE__) . '/rokbrowser_check.php');

$browser_check = new RokBrowserCheck;
$platform = $browser_check->platform;

// Widget

class RokIntroScroller extends WP_Widget {

	// RocketTheme RokIntroScroller Widget
	// Port by Jakub Baran

	static $plugin_path;
	static $plugin_url;
	var $short_name = 'rokintroscroller';
	var $long_name = 'RokIntroScroller';
	var $description = 'RocketTheme RokIntroScroller Widget';
	var $css_classname = 'widget_rokintroscroller';
	var $width = 200;
	var $height = 400;
	var $_defaults = array(
		'title' => '',
		'category' => 'uncategorized',
		'order' => 'date',
		'post_title' => 0,
		'post_title_link' => 0,
		'thumbs' => 1,
		'thumb_link' => 1,
		'show_content' => 1,
		'more' => 1,
		'more_label' => 'Read More'
	);

	function init() {
		global $platform;
		if($platform != 'iphone' && $platform != 'android') :
			register_widget("RokIntroScroller");
		endif;
		if(!is_admin() && $platform != 'iphone' && $platform != 'android') {
			add_action('wp_enqueue_scripts', 'rokintroscroller_script', 7);
			add_action('wp_head', 'rokintroscroller_script_inline');
		}

	}

	function render($args, $instance) {
		global $gantry, $more, $post, $rokintroscroller_plugin_path, $rokintroscroller_plugin_url;
		
		$option = get_option('rokintroscroller_options');
		$get_id = 'widget-' . $args['widget_id'];
		$catid = get_category_by_slug($instance['category']);
		
		ob_start();
		echo $args['before_widget'];
		if($instance['title'] != '')
		echo $args['before_title'] . $instance['title'] . $args['after_title']; 		
		
		?>
		
		<?php if (get_posts('cat='.$catid->term_id)) {
				
				if(file_exists(TEMPLATEPATH . '/html/plugins/wp_rokintroscroller/default.php')) :	
					require(TEMPLATEPATH . '/html/plugins/wp_rokintroscroller/default.php');
				else :
					require($rokintroscroller_plugin_path . '/tmpl/default.php'); 
				endif;
			
			wp_reset_query();
			
			} else {
			
			_e('Sorry, but your category is empty!', 'rokintroscroller');
			
			} ?>
		
			<div class="clear"></div>
		
		<?php
		
		echo $args['after_widget'];
		echo ob_get_clean();
	}
	
	function form($instance) {
		global $rokintroscroller_plugin_path, $rokintroscroller_plugin_url;
		$defaults = $this->_defaults;
		$instance = wp_parse_args((array) $instance, $defaults);
		foreach ($instance as $variable => $value)
		{
			$$variable = self::_cleanOutputVariable($variable, $value);
			$instance[$variable] = $$variable;
		}
		$this->_values = $instance;
		
		$categories = get_terms('category', 'hide_empty=0&orderby=name');
		
		ob_start();
		?>

		<label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title', 'rokintroscroller'); ?>:&nbsp;
		<input style="width: 165px;" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $instance['title']; ?>" /></label>
		<br /><br />
		<label for="<?php echo $this->get_field_id('category'); ?>"><?php _e('Posts Category:', 'rokintroscroller'); ?></label>&nbsp;
		<select name="<?php echo $this->get_field_name('category'); ?>" id="<?php echo $this->get_field_id('category'); ?>">
			<?php foreach ($categories as $cat) { ?>
				<option value="<?php echo $cat->slug; ?>"<?php if($instance['category'] == $cat->slug) : echo ' selected="selected"'; endif; ?>><?php echo $cat->name; ?></option>
			<?php } ?>
		</select>
		<br /><br />
		<label for="<?php echo $this->get_field_id('order'); ?>"><?php _e('Order:', 'rokintroscroller'); ?></label>&nbsp;
		<select id="<?php echo $this->get_field_id('order'); ?>" name="<?php echo $this->get_field_name('order'); ?>">
			<option value="author"<?php selected( $instance['order'], 'author' ); ?>><?php _e('Author', 'rokintroscroller'); ?></option>
			<option value="date"<?php selected( $instance['order'], 'date' ); ?>><?php _e('Date', 'rokintroscroller'); ?></option>
			<option value="title"<?php selected( $instance['order'], 'title' ); ?>><?php _e('Title', 'rokintroscroller'); ?></option>
			<option value="modified"<?php selected( $instance['order'], 'modified' ); ?>><?php _e('Modified', 'rokintroscroller'); ?></option>
			<option value="menu_order"<?php selected( $instance['order'], 'menu_order' ); ?>><?php _e('Menu Order', 'rokintroscroller'); ?></option>
			<option value="parent"<?php selected( $instance['order'], 'parent' ); ?>><?php _e('Parent', 'rokintroscroller'); ?></option>
			<option value="id"<?php selected( $instance['order'], 'id' ); ?>>ID</option>
		</select>
		<br /><br />
		<?php _e('Display Post Title:', 'rokintroscroller'); ?>
		<input id="<?php echo $this->get_field_id('post_title'); ?>1" type="radio" value="1" name="<?php echo $this->get_field_name('post_title'); ?>" <?php if($instance['post_title'] == 1) echo 'checked="checked"'; ?>/>
		<label for="<?php echo $this->get_field_id('post_title'); ?>1"><?php _e('Yes', 'rokintroscroller'); ?></label>&nbsp;&nbsp;
		<input id="<?php echo $this->get_field_id('post_title'); ?>0" type="radio" value="0" name="<?php echo $this->get_field_name('post_title'); ?>" <?php if($instance['post_title'] == 0) echo 'checked="checked"'; ?>/>
		<label for="<?php echo $this->get_field_id('post_title'); ?>0"><?php _e('No', 'rokintroscroller'); ?></label>
		<br /><br />
		<?php _e('Link Post Title:', 'rokintroscroller'); ?>
		<input id="<?php echo $this->get_field_id('post_title_link'); ?>1" type="radio" value="1" name="<?php echo $this->get_field_name('post_title_link'); ?>" <?php if($instance['post_title_link'] == 1) echo 'checked="checked"'; ?>/>
		<label for="<?php echo $this->get_field_id('post_title_link'); ?>1"><?php _e('Yes', 'rokintroscroller'); ?></label>&nbsp;&nbsp;
		<input id="<?php echo $this->get_field_id('post_title_link'); ?>0" type="radio" value="0" name="<?php echo $this->get_field_name('post_title_link'); ?>" <?php if($instance['post_title_link'] == 0) echo 'checked="checked"'; ?>/>
		<label for="<?php echo $this->get_field_id('post_title_link'); ?>0"><?php _e('No', 'rokintroscroller'); ?></label>
		<br /><br />
		<?php _e('Display Post Content:', 'rokintroscroller'); ?>
		<input id="<?php echo $this->get_field_id('show_content'); ?>1" type="radio" value="1" name="<?php echo $this->get_field_name('show_content'); ?>" <?php if($instance['show_content'] == 1) echo 'checked="checked"'; ?>/>
		<label for="<?php echo $this->get_field_id('show_content'); ?>1"><?php _e('Yes', 'rokintroscroller'); ?></label>&nbsp;&nbsp;
		<input id="<?php echo $this->get_field_id('show_content'); ?>0" type="radio" value="0" name="<?php echo $this->get_field_name('show_content'); ?>" <?php if($instance['show_content'] == 0) echo 'checked="checked"'; ?>/>
		<label for="<?php echo $this->get_field_id('show_content'); ?>0"><?php _e('No', 'rokintroscroller'); ?></label>
		<br /><br />
		<?php _e('Display Thumbnails:', 'rokintroscroller'); ?>
		<input id="<?php echo $this->get_field_id('thumbs'); ?>1" type="radio" value="1" name="<?php echo $this->get_field_name('thumbs'); ?>" <?php if($instance['thumbs'] == 1) echo 'checked="checked"'; ?>/>
		<label for="<?php echo $this->get_field_id('thumbs'); ?>1"><?php _e('Yes', 'rokintroscroller'); ?></label>&nbsp;&nbsp;
		<input id="<?php echo $this->get_field_id('thumbs'); ?>0" type="radio" value="0" name="<?php echo $this->get_field_name('thumbs'); ?>" <?php if($instance['thumbs'] == 0) echo 'checked="checked"'; ?>/>
		<label for="<?php echo $this->get_field_id('thumbs'); ?>0"><?php _e('No', 'rokintroscroller'); ?></label>
		<br /><br />
		<?php _e('Link Thumbnails:', 'rokintroscroller'); ?>
		<input id="<?php echo $this->get_field_id('thumb_link'); ?>1" type="radio" value="1" name="<?php echo $this->get_field_name('thumb_link'); ?>" <?php if($instance['thumb_link'] == 1) echo 'checked="checked"'; ?>/>
		<label for="<?php echo $this->get_field_id('thumb_link'); ?>1"><?php _e('Yes', 'rokintroscroller'); ?></label>&nbsp;&nbsp;
		<input id="<?php echo $this->get_field_id('thumb_link'); ?>0" type="radio" value="0" name="<?php echo $this->get_field_name('thumb_link'); ?>" <?php if($instance['thumb_link'] == 0) echo 'checked="checked"'; ?>/>
		<label for="<?php echo $this->get_field_id('thumb_link'); ?>0"><?php _e('No', 'rokintroscroller'); ?></label>
		<br /><br />
		<?php _e('Show "More" Button:', 'rokintroscroller'); ?>
		<input id="<?php echo $this->get_field_id('more'); ?>1" type="radio" value="1" name="<?php echo $this->get_field_name('more'); ?>" <?php if($instance['more'] == 1) echo 'checked="checked"'; ?>/>
		<label for="<?php echo $this->get_field_id('more'); ?>1"><?php _e('Yes', 'rokintroscroller'); ?></label>&nbsp;&nbsp;
		<input id="<?php echo $this->get_field_id('more'); ?>0" type="radio" value="0" name="<?php echo $this->get_field_name('more'); ?>" <?php if($instance['more'] == 0) echo 'checked="checked"'; ?>/>
		<label for="<?php echo $this->get_field_id('more'); ?>0"><?php _e('No', 'rokintroscroller'); ?></label>
		<br /><br />
		<label for="<?php echo $this->get_field_id('more_label'); ?>"><?php _e('"More" Button Label:', 'rokintroscroller'); ?>&nbsp;
		<input style="width: 100px;" id="<?php echo $this->get_field_id('more_label'); ?>" name="<?php echo $this->get_field_name('more_label'); ?>" type="text" value="<?php echo $instance['more_label']; ?>" /></label>
		<hr style="border: none; border-bottom: 1px dashed #919191; margin-top: 10px;" />
		<h3><?php _e('Debug Information', 'rokintroscroller'); ?></h3>
	   
		<?php
		
		_e('GD2 Library Present: ', 'rokintroscroller');
		
		if (extension_loaded('gd') && function_exists('gd_info')) {
			echo '<span style="color: #177F08; font-weight: bold;">'.__('YES', 'rokintroscroller').'</span>';
		} else {
			echo '<span style="color: #C30C0C; font-weight: bold;">'.__('NO', 'rokintroscroller').'</span>';
		}
		
		echo '<br />';
		_e('Cache Directory Writeable: ', 'rokintroscroller');
		
		if (is_writeable($rokintroscroller_plugin_path . '/cache')) {
			echo '<span style="color: #177F08; font-weight: bold;">'.__('YES', 'rokintroscroller').'</span><br /><br />';
		} else {
			echo '<span style="color: #C30C0C; font-weight: bold;">'.__('NO', 'rokintroscroller').'</span><br /><br />';
		}
	
		echo ob_get_clean();
	}
	
	 /********** Bellow here should not need to be changed***********/

	function __construct() {
		if (empty($this->short_name) || empty($this->long_name)) {
			die("A widget must have a valid type and classname defined");
		}
		$widget_options = array('classname' => $this->css_classname, 'description' => __($this->description));
		$control_options = array('width' => $this->width, 'height' => $this->height);
		parent::__construct($this->short_name, $this->long_name, $widget_options, $control_options);
	}

	function _cleanOutputVariable($variable, $value) {
		if (is_string($value)) {
			return htmlspecialchars($value);
		}
		elseif (is_array($value)) {
			foreach ($value as $subvariable => $subvalue) {
				$value[$subvariable] = self::_cleanOutputVariable($subvariable, $subvalue);
			}
			return $value;
		}
		return $value;
	}

	function _cleanInputVariable($variable, $value) {
		if (is_string($value)) {
			return stripslashes($value);
		}
		elseif (is_array($value)) {
			foreach ($value as $subvariable => $subvalue) {
				$value[$subvariable] = self::_cleanInputVariable($subvariable, $subvalue);
			}
			return $value;
		}
		return $value;
	}

	function widget($args, $instance){
		global $gantry;
		extract($args);
		$defaults = $this->_defaults;
		$instance = wp_parse_args((array) $instance, $defaults);
		foreach ($instance as $variable => $value)
		{
			$$variable = self::_cleanOutputVariable($variable, $value);
			$instance[$variable] = $$variable;
		}
		$this->render($args, $instance);
	}

}

RokIntroScroller::$plugin_path = dirname($plugin);
RokIntroScroller::$plugin_url = WP_PLUGIN_URL . '/' . basename(RokIntroScroller::$plugin_path);

add_action('widgets_init', array("RokIntroScroller", "init"));

// Load Language

load_plugin_textdomain('rokintroscroller', false, basename($rokintroscroller_plugin_path) . '/languages/');

// MooTools Enqueue Script

add_action('init','rokintroscroller_mootools_init',-50);

function rokintroscroller_mootools_init(){
	global $rokintroscroller_plugin_path, $rokintroscroller_plugin_url;
	wp_register_script('mootools.js', $rokintroscroller_plugin_url . '/js/mootools.js');
	wp_enqueue_script('mootools.js');
}

// RokIntroScroller defaults

function rokintroscroller_options() {
	
	$rokintroscroller_options = array(
	
		'content_type' => 'content',
		'posts_per_page' => '5',
		'thumb_width' => '212',
		'thumb_height' => '150',
		'duration' => '800',
		'items_per_click' => '2',
		'arrows_opacity' => '0.35',
		'allowed_tags' => 'a,br,strong,em,img,b',
		'thumb_generator' => 'default'
		
	);
	
	add_option('rokintroscroller_options', $rokintroscroller_options);
}

add_action('init','rokintroscroller_options');
	
// RokIntroScroller Admin Stuff Settings

function rokintroscroller_admin_stuff() {
	register_setting('rokintroscroller_options_array', 'rokintroscroller_options');
}

if(is_admin()) {
	add_action('admin_init', 'rokintroscroller_admin_stuff');
}

// Add scripts

function rokintroscroller_script() {
	global $rokintroscroller_plugin_path, $rokintroscroller_plugin_url;
	wp_register_script('rokintroscroller.js', $rokintroscroller_plugin_url . '/js/rokintroscroller.js');
	wp_enqueue_script('rokintroscroller.js');
}

function rokintroscroller_script_inline() {

	$option = get_option('rokintroscroller_options');

	$rokintroscroller_init = "window.addEvent('domready', function() {
			var rnu = new RokIntroScroller('rokintroscroller', {
				'arrows': {
					'effect': true,
					'opacity': " . $option['arrows_opacity'] . "
				},
				'scroll': {
					'duration': " . $option['duration'] . ",
					'itemsPerClick': " . $option['items_per_click'] . ",
					'transition': Fx.Transitions.Quad.easeOut
				}
			});
		})";

	echo "<script type=\"text/javascript\">\n$rokintroscroller_init\n</script>\n";

}

// Add RokIntroScroller meta box

function rokintroscroller_add_custom_box() {
	 add_meta_box('rokintroscroller_box', 'RokIntroScroller', 'rokintroscroller_custom_box', 'post', 'normal', 'high');
}

function rokintroscroller_custom_box() {
	global $post;
	$rokintroscroller_image = get_post_meta($post->ID, '_rokintroscroller_thumb', true);	
	echo '<input type="hidden" name="rokintroscroller_noncename" id="rokintroscroller_noncename" value="' . wp_create_nonce('rt_rokintroscroller') . '" />';
	echo '<p>' . __('If automatic thumbnails aren\'t working for you please check if the <b>cache</b> directory inside of the RokIntroScroller plugin dir has proper permissions or ask for the support in the RocketTheme forums.', 'rokintroscroller') . '<br /><br />';
	echo '<label for="rt_image_box">' . __('Image Path:', 'rokintroscroller') . '</label> ';
	echo '<input type="text" class="code" value="' . $rokintroscroller_image . '" id="rt_rokintroscroller_box" name="rt_rokintroscroller_box" style="width:99%;" /></p>';
}

function rokintroscroller_save_data($post_id) {
	 // verify this with nonce because save_post can be triggered at other times
	 if (!wp_verify_nonce($_POST['rokintroscroller_noncename'], 'rt_rokintroscroller')) return $post_id;
	 
	 // do not save if this is an auto save routine
	 if (defined('DOING_AUTOSAVE') && DOING_AUTOSAVE) return $post_id;

	 $rt_rokintroscroller_box = trim($_POST['rt_rokintroscroller_box']);
	 if($rt_rokintroscroller_box != '') :
		update_post_meta($post_id, '_rokintroscroller_thumb', $rt_rokintroscroller_box);
	 else:
		delete_post_meta($post_id, '_rokintroscroller_thumb');
	 endif;
}

add_action('save_post', 'rokintroscroller_save_data');
add_action('admin_menu', 'rokintroscroller_add_custom_box');

// Add Settings

function rokintroscroller_settings_add($links) {
	$settings_link = '<a href="plugins.php?page=rokintroscroller-settings">' . __('Settings') . '</a>';
	array_unshift($links, $settings_link);
	return $links;
}

function rokintroscroller_settings_action() {
	$plugin = plugin_basename(__FILE__); 
	add_filter('plugin_action_links_' . $plugin, 'rokintroscroller_settings_add');
}

add_action('admin_menu', 'rokintroscroller_settings_action');

// Plugin settings page

function rokintroscroller_menu() {
	add_plugins_page('RokIntroScroller', 'RokIntroScroller', 'activate_plugins', 'rokintroscroller-settings', 'rokintroscroller_settings_showup');  
}

add_action('admin_menu', 'rokintroscroller_menu', 9);

function rokintroscroller_admin_css() { ?>
	
	<style type="text/css">
	.rokintroscroller-table table tr {height: 35px;}
	.rokintroscroller-table table td {vertical-align: middle;}
	.rokintroscroller-table .button-primary {font-family: sans-serif;}
	</style>

<?php 

}

if(is_admin() && (isset($_GET['page']) && $_GET['page'] == 'rokintroscroller-settings')) {
	add_action('admin_head', 'rokintroscroller_admin_css');
}

// RokIntroScroller settings page

function rokintroscroller_settings_showup() {
	
	$option = get_option('rokintroscroller_options');
	
	if(isset($_GET['updated']) && $_GET['updated'] == 'true') { ?><div id="message" class="updated fade"><p><?php _e('RokIntroScroller settings saved.', 'rokintroscroller'); ?></p></div><?php } ?>
	
	<div class="wrap">
		<h2>RokIntroScroller <?php _e('Settings'); ?></h2><br />
		
		<div style="margin: 0 auto; width: 50%;" class="rokintroscroller-table">
		
			<form method="post" action="options.php">
				<?php settings_fields('rokintroscroller_options_array'); ?>
				
				<table cellspacing="0" class="widefat fixed">
					<thead>
						<tr>
							<th><?php _e('Option Name', 'rokintroscroller'); ?></th>
							<th>
								<?php _e('Value', 'rokintroscroller'); ?>
							</th>
						</tr>
					</thead>
					<tfoot>
						<tr>
							<th></th>
							<th>
								<input type="submit" class="button-primary" value="<?php _e('Save Changes', 'rokintroscroller'); ?>" style="padding: 3px; float: right;" />
							</th>
						</tr>
					</tfoot>
					<tbody>
						<tr valign="middle" class="iedit">
							<td>
								<b><?php _e('Content Type:', 'rokintroscroller'); ?></b></td>
							<td>
								<select id="content_type" name="rokintroscroller_options[content_type]">
									<option value="content" <?php if ($option['content_type'] == "content") : ?>selected="selected"<?php endif; ?>><?php _e('Content', 'rokintroscroller'); ?></option>
									<option value="excerpt" <?php if ($option['content_type'] == "excerpt") : ?>selected="selected"<?php endif; ?>><?php _e('Excerpt', 'rokintroscroller'); ?></option>
								</select>
							</td>
						</tr>
						<tr valign="middle" class="alternate iedit">
							<td>
								<b><?php _e('Maximum Number of Posts:', 'rokintroscroller'); ?></b></td>
							<td>
								<input id="posts_per_page" type="text" value="<?php echo $option['posts_per_page']; ?>" size="20" name="rokintroscroller_options[posts_per_page]" />
							</td>
						</tr>
						<tr valign="middle" class="iedit">
							<td>
								<b><?php _e('Thumbnail Dimensions:', 'rokintroscroller'); ?></b></td>
							<td>
								<input id="thumb_width" type="text" value="<?php echo $option['thumb_width']; ?>" size="6" name="rokintroscroller_options[thumb_width]" />px x
								<input id="thumb_height" type="text" value="<?php echo $option['thumb_height']; ?>" size="6" name="rokintroscroller_options[thumb_height]" />px
							</td>
						</tr>
						<tr valign="middle" class="alternate iedit">
							<td>
								<b><?php _e('Thumbnails Generator:', 'rokintroscroller'); ?></b></td>
							<td>
								<select id="thumb_generator" name="rokintroscroller_options[thumb_generator]">
									<option value="default" <?php if ($option['thumb_generator'] == "default") : ?>selected="selected"<?php endif; ?>><?php _e('Default', 'rokintroscroller'); ?></option>
									<option value="phpthumb" <?php if ($option['thumb_generator'] == "phpthumb") : ?>selected="selected"<?php endif; ?>>PHPThumb</option>
								</select>
							</td>
						</tr>
						<tr valign="middle" class="iedit">
							<td>
								<b><?php _e('Transition Duration:', 'rokintroscroller'); ?></b></td>
							<td>
								<input id="duration" type="text" value="<?php echo $option['duration']; ?>" size="20" name="rokintroscroller_options[duration]" />ms
							</td>
						</tr>
						<tr valign="middle" class="alternate iedit">
							<td>
								<b><?php _e('Items Per Click:', 'rokintroscroller'); ?></b></td>
							<td>
								<input id="items_per_click" type="text" value="<?php echo $option['items_per_click']; ?>" size="20" name="rokintroscroller_options[items_per_click]" />
							</td>
						</tr>
						<tr valign="middle" class="iedit">
							<td>
								<b><?php _e('Arrows Opacity:', 'rokintroscroller'); ?></b></td>
							<td>
								<input id="arrows_opacity" type="text" value="<?php echo $option['arrows_opacity']; ?>" size="20" name="rokintroscroller_options[arrows_opacity]" />
							</td>
						</tr>
						<tr valign="middle" class="alternate iedit">
							<td>
								<b><?php _e('Allowed HTML Tags:', 'rokintroscroller'); ?></b></td>
							<td>
								<input id="allowed_tags" type="text" value="<?php echo $option['allowed_tags']; ?>" size="20" name="rokintroscroller_options[allowed_tags]" />
							</td>
						</tr>
					</tbody>
				</table>
			</form>
		
		</div>
		
	</div>

<?php
 
}

// Prepare Content

if(!function_exists('prepareContent')) {
	function prepareContent($text, $tags_option) {
	
		$tags = explode(",", $tags_option);
		$strip_tags = array();
		for($i = 0; $i < count($tags); $i++) {
			$strip_tags[$i] = '<'.trim($tags[$i]).'>';
		}
		$tags = implode(',', $strip_tags);
		
		// strips tags won't remove the actual jscript
		$text = preg_replace( "'<script[^>]*>.*?</script>'si", "", $text );
		$text = preg_replace( '/{.+?}/', '', $text);
		//$text = preg_replace( "'<(br[^/>]*?/|hr[^/>]*?/|/(div|h[1-6]|li|p|td))>'si", ' ', $text );
		$text = strip_tags($text, $tags);
		
		return $text;

	}	
}

// Experimental image resize

/*
 * Resize images dynamically using wp built in functions
 * Victor Teixeira
 *
 * php 5.2+
 *
 * Example of use :
 * 
 * <?php 
 * $thumb = get_post_thumbnail_id(); 
 * $image = rokintroscroller_resize( $thumb, '', 140, 110, true );
 * ?>
 * <img src="<?php echo $image[url]; ?>" width="<?php echo $image[width]; ?>" height="<?php echo $image[height]; ?>" />
 *
 * @param int $attach_id
 * @param string $img_url
 * @param int $width
 * @param int $height
 * @param bool $crop
 * @return array
 */
 
if(!function_exists('rokintroscroller_resize')) {
	function rokintroscroller_resize( $attach_id = null, $img_url = null, $width, $height, $crop = false ) {
	
		global $rokintroscroller_plugin_path, $rokintroscroller_plugin_url;
	
		// this is an attachment, so we have the ID
		if ( $attach_id ) {
		
			$image_src = wp_get_attachment_image_src( $attach_id, 'full' );
			$file_path = get_attached_file( $attach_id );
		
		// this is not an attachment, let's use the image url
		} else if ( $img_url ) {
			
			$file_path = parse_url( $img_url );
			$file_path = $_SERVER['DOCUMENT_ROOT'] . $file_path['path'];
			
			//$file_path = ltrim( $file_path['path'], '/' );
			//$file_path = rtrim( ABSPATH, '/' ).$file_path['path'];
			
			$orig_size = @getimagesize( $file_path );
			
			$image_src[0] = $img_url;
			$image_src[1] = $orig_size[0];
			$image_src[2] = $orig_size[1];
		}
		
		$file_info = pathinfo( $file_path );
		$extension = '.'. $file_info['extension'];
	
		// the image path without the extension
		$no_ext_path = $rokintroscroller_plugin_path.'/cache/'.$file_info['filename'];
	
		$cropped_img_path = $no_ext_path.'-'.$width.'x'.$height.$extension;
	
		// checking if the file size is larger than the target size
		// if it is smaller or the same size, stop right here and return
		if ( $image_src[1] > $width || $image_src[2] > $height ) {
	
			// the file is larger, check if the resized version already exists (for $crop = true but will also work for $crop = false if the sizes match)
			if ( file_exists( $cropped_img_path ) ) {
	
				$default_url = str_replace(basename($image_src[0]), basename($cropped_img_path), $image_src[0]);
				$cropped_img_url = str_replace(dirname($image_src[0]), $rokintroscroller_plugin_url.'/cache', $default_url);
				
				$vt_image = array (
					'url' => $cropped_img_url,
					'width' => $width,
					'height' => $height
				);
				
				return $vt_image;
			}
	
			// $crop = false
			if ( $crop == false ) {
			
				// calculate the size proportionaly
				$proportional_size = wp_constrain_dimensions( $image_src[1], $image_src[2], $width, $height );
				$resized_img_path = $no_ext_path.'-'.$proportional_size[0].'x'.$proportional_size[1].$extension;		
	
				// checking if the file already exists
				if ( file_exists( $resized_img_path ) ) {
				
					$default_url = str_replace( basename( $image_src[0] ), basename( $resized_img_path ), $image_src[0] );
					$resized_img_url = str_replace(dirname($image_src[0]), $rokintroscroller_plugin_url.'/cache', $default_url);
	
					$vt_image = array (
						'url' => $resized_img_url,
						'width' => $proportional_size[0],
						'height' => $proportional_size[1]
					);
					
					return $vt_image;
				}
			}
	
			// no cache files - let's finally resize it
			$new_img_path = image_resize( $file_path, $width, $height, $crop, '', $rokintroscroller_plugin_path.'/cache' );
			$new_img_size = getimagesize( $new_img_path );
			$default_url = str_replace( basename( $image_src[0] ), basename( $new_img_path ), $image_src[0] );
			$new_img = str_replace(dirname($image_src[0]), $rokintroscroller_plugin_url.'/cache', $default_url);
	
			// resized output
			$vt_image = array (
				'url' => $new_img,
				'width' => $new_img_size[0],
				'height' => $new_img_size[1]
			);
			
			return $vt_image;
		}
	
		// default output - without resizing
		$vt_image = array (
			'url' => $image_src[0],
			'width' => $image_src[1],
			'height' => $image_src[2]
		);
		
		return $vt_image;
	}
}

?>